﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using System.Runtime.InteropServices;



namespace UFIDA.U8.Portal.GuaZhangQueR
{
    //主要读取库UFSystem的配置文件类
    public class ClsSynchroData
    {
        //登录为静态只登录一次不然多次登录会很慢
        private static U8Login.clsLogin u8Login;

        /// <summary>
        /// 获取DataSheet的信息
        /// </summary>
        /// <param name="strItemCode"></param>
        /// <param name="voucherkey"></param>
        /// <param name="strfieldkey"></param>
        /// <param name="strField"></param>
        /// <returns></returns>
     
    

        /// <summary>
        /// 生成单据的xml对象
        /// </summary>
        /// <param name="strVoucherKey"></param>
   
        public U8Login.clsLogin GetU8Login(string strVoucherKey)
        {
            string strSQL;
            string msg;
            string sAccID = "";
            string sYear = "";
            string sUserID = "";
            string sPassword = "";
            string sDate = "";
            string sServer = "";
            string sSerial = "";
            string sSubId = "";
            DataTable dtServer;
            strSQL = "SELECT voucherKey,module,sSerLogAccID,sSubId, sYear, sUserID, sPassword, sDate, sServer, sSerial FROM "
                    + " UFSystem.dbo.sysserverinfo where voucherKey='" + strVoucherKey + "'";
            dtServer = SqlHelper.GetDataTableCheckRows(SqlHelper.ConnectionString, strSQL);

            try
            {
                sSubId = dtServer.Rows[0]["module"].ToString();
                sAccID = dtServer.Rows[0]["sSerLogAccID"].ToString();
                sYear = DateTime.Now.Year.ToString();
                sUserID = dtServer.Rows[0]["sUserID"].ToString();
                sPassword = dtServer.Rows[0]["sPassword"].ToString();
                sDate = dtServer.Rows[0]["sDate"].ToString();
                if (sDate == "")
                {
                    sDate = DateTime.Now.ToString("yyyy-MM-dd");
                }
                sServer = dtServer.Rows[0]["sServer"].ToString();
                if (u8Login != null)
                {
                    if (u8Login.DataSource != null)
                    {
                        if (u8Login.DataSource.IndexOf(sAccID) > -1 && u8Login.CurDate.ToString().IndexOf(DateTime.Now.ToString("yyyy-MM-dd")) > -1)
                        {
                            return u8Login;
                        }
                        //要重新登录关闭一下登录
                        u8Login.ShutDown();
                    }
                }
                u8Login = new U8Login.clsLogin();
                if (!u8Login.Login(ref sSubId, ref sAccID, ref sYear, ref sUserID, ref sPassword, ref sDate, ref sServer, ref sSerial))
                {
                    msg = "登陆失败，原因：" + u8Login.ShareString;
                    Marshal.FinalReleaseComObject(u8Login);
                    throw new Exception(msg);
                }
            }
            catch (Exception ex)
            {
                u8Login = null;
                throw new Exception(ex.ToString());
            }
            return u8Login;
        }


        /// <summary>
        /// 获取链接字符串
        /// </summary>
        /// <param name="strid">sysdb表的id字段</param>
        /// <returns></returns>
        public static string GetDBConnstring(string dbcode)
        {
            string strSQL;
            DataTable dt;
            strSQL = "SELECT connstring FROM  t_gys_db with(nolock) WHERE dbcode=" + dbcode;
            dt =SqlHelper.GetDataTableCheckRows(SqlHelper.ConnectionString, strSQL);
            return dt.Rows[0]["connstring"].ToString();
        }
        /// <summary>
        ///  写错误日志
        /// </summary>
        /// <param name="log"></param>
        /// <param name="bReplace">为true就覆盖</param>
        /// <returns></returns>
        /// 
        public static void WriteSqlLog(ClsLog log, bool bReplace = true)
        {
            string strTempSQL;
            string strSQL;
            string strDetailSQL;
            //该表为明细表
            strDetailSQL = "INSERT INTO t_gys_logs(cvoucherid,cvoucherkey,sourceCode,result,date,[message],"
                + " xtresult,xtdate,xtmessage,cmemo,xttype,startTime,endTime,GysCode,guazhangqijian) "
                + " Values(@cvoucherid,@cvoucherkey,@sourceCode ,@result,@date,@message,"
                + " @xtresult,@xtdate,@xtmessage,@cmemo,@xttype,@startTime,@endTime,@GysCode,@guazhangqijian)";
            if (log.guazhangqijian == "")
            {
                strTempSQL = "select 1 from  t_gys_log where cvoucherkey='" + log.cvoucherkey + "' and sourceCode='"
                    + log.sourceCode + "'";
            }
            else
            {
                strTempSQL = "select 1 from  t_gys_log where cvoucherkey='" + log.cvoucherkey + "' and sourceCode='"
                    + log.sourceCode + "' and guazhangqijian='"+log.guazhangqijian+"'";
            }
            SqlDataReader sdr =SqlHelper.GetReader(SqlHelper.ConnectionString, strTempSQL);
            if (sdr.Read() || bReplace == false)
            {
                if (log.guazhangqijian != "")
                {
                    strSQL = " UPDATE  t_gys_log SET [result]=@result , "
                        + "[cvoucherid]=@cvoucherid,[xtdate]=@xtdate ,"
                        + "[date]=@date,[xtmessage]=@message,"
                        + "[xtresult]=@xtresult,[message]=@message,[cmemo]=@cmemo,[xttype]=@xttype  where"
                        + " cvoucherkey=@cvoucherkey and sourceCode=@sourceCode and guazhangqijian=@guazhangqijian";
                }
                else
                {
                    strSQL = " UPDATE  t_gys_log SET [result]=@result , "
                       + "[cvoucherid]=@cvoucherid,[xtdate]=@xtdate ,"
                       + "[date]=@date,[xtmessage]=@message,"
                       + "[xtresult]=@xtresult,[message]=@message,[cmemo]=@cmemo,[xttype]=@xttype  where"
                       + " cvoucherkey=@cvoucherkey and sourceCode=@sourceCode";
                }
            }
            else
            {
                strSQL = "INSERT INTO t_gys_log(cvoucherid,cvoucherkey,sourceCode,result,date,[message],"
                    + " xtresult,xtdate,xtmessage,cmemo,xttype,startTime,endTime,GysCode,guazhangqijian) "
                    + "Values(@cvoucherid,@cvoucherkey,@sourceCode ,@result,@date,@message,"
                    + " @xtresult,@xtdate,@xtmessage,@cmemo,@xttype,@startTime,@endTime,@GysCode,@guazhangqijian)";

            }
            sdr.Close();

            SqlParameter[] parasUpdate = new SqlParameter[]
           {   new SqlParameter("@cvoucherid", log.cvoucherid ),new SqlParameter("@cvoucherkey",log.cvoucherkey) ,
                new SqlParameter("@sourceCode",log.sourceCode),new SqlParameter("@result",log.result) ,
                new SqlParameter("@date",DateTime.Now),new SqlParameter("@message",log.message),
                new SqlParameter("@xtresult",log.xtresult),new SqlParameter("@xtdate",DateTime.Now) ,
                new SqlParameter("@xtmessage",log.xtmessage) , new SqlParameter("@cmemo",log.cmemo),
              new SqlParameter("@xttype",log.xttype),
             new SqlParameter("@guazhangqijian", log.guazhangqijian)
             
           };

            SqlParameter[] paras = new SqlParameter[]
            {   new SqlParameter("@cvoucherid", log.cvoucherid ),new SqlParameter("@cvoucherkey",log.cvoucherkey) ,
                new SqlParameter("@sourceCode",log.sourceCode),new SqlParameter("@result",log.result) ,
                new SqlParameter("@date",DateTime.Now),new SqlParameter("@message",log.message),
                new SqlParameter("@xtresult",log.xtresult),new SqlParameter("@xtdate",DateTime.Now) ,
                new SqlParameter("@xtmessage",log.xtmessage) , new SqlParameter("@cmemo",log.cmemo),
              new SqlParameter("@xttype",log.xttype),
              new SqlParameter("@startTime", log.startTime),
              new SqlParameter("@endTime", log.endTime),
              new SqlParameter("@GysCode", log.GysCode),
              new SqlParameter("@guazhangqijian", log.guazhangqijian)
            };


            if (strSQL.Contains("INSERT"))
            {
                SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, strSQL, paras);
            }
            else
            {
                SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, strSQL, parasUpdate);
            }
            
            //写明细日志

            SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, strDetailSQL, paras);
            //写日志     
        }
        /// <summary>
        /// 写操作日志
        /// </summary>
        /// <param name="strOperateType">操作方法</param>
        /// <param name="log"></param>
        /// <returns></returns>
        public static void WriteSqlLog(List<ClsLog> listLogs, bool bReplace = true)
        {
            if (listLogs == null||listLogs.Count<=0)
            {
                return;
            }

            string strTempSQL;
            string strSQL;
            string strDetailSQL;
            StringBuilder sbDetail = new StringBuilder();
            StringBuilder sbSql = new StringBuilder();
            //该表为明细表
            List<SqlParameter> paras = new List<SqlParameter>();

            for (int i = 0; i < listLogs.Count; i++)
            {
                var log = listLogs[i];
                strDetailSQL = "INSERT INTO t_gys_logs(cvoucherid,cvoucherkey,sourceCode,result,date,[message],"
                + " xtresult,xtdate,xtmessage,cmemo,xttype,startTime,endTime,GysCode,guazhangqijian) "
                + " Values(@cvoucherid" + i + ",@cvoucherkey" + i + ",@sourceCode" + i + " ,@result" + i + ",@date" + i + ",@message" + i + ","
                + " @xtresult" + i + ",@xtdate" + i + ",@xtmessage" + i + ",@cmemo" + i + ",@xttype" + i + ",@startTime"+ i + ",@endTime" + i + ",@GysCode"+i+ ",@guazhangqijian"+i+")";
                paras.Add(new SqlParameter("@cvoucherid" + i, log.cvoucherid));
                paras.Add(new SqlParameter("@cvoucherkey" + i, log.cvoucherkey));
                paras.Add(new SqlParameter("@sourceCode" + i, log.sourceCode));
                paras.Add(new SqlParameter("@result" + i, log.result));
                paras.Add(new SqlParameter("@date" + i, DateTime.Now));
                paras.Add(new SqlParameter("@message" + i, log.message));
                paras.Add(new SqlParameter("@xtresult" + i, log.xtresult));
                paras.Add(new SqlParameter("@xtdate" + i, DateTime.Now));
                paras.Add(new SqlParameter("@xtmessage" + i, log.xtmessage));
                paras.Add(new SqlParameter("@cmemo" + i, log.cmemo));
                paras.Add(new SqlParameter("@xttype" + i, log.xttype));
                paras.Add(new SqlParameter("@startTime" + i, log.startTime));
                paras.Add(new SqlParameter("@endTime" + i, log.endTime));
                paras.Add(new SqlParameter("@GysCode" + i, log.GysCode));
                paras.Add(new SqlParameter("@guazhangqijian" + i, log.guazhangqijian));
                sbDetail.Append(strDetailSQL + "\r\n");
            }
            List<string> listKeyAndCode = new List<string>();

            string keys = string.Join(",", listLogs.Select(l => { if (string.IsNullOrEmpty(l.cvoucherkey)) return "''"; return "'" + l.cvoucherkey + "'"; }).ToList<string>().Where(lo => lo != "''").ToArray());

            string cvoucherids = string.Join(",", listLogs.Select(l => { if (string.IsNullOrEmpty(l.cvoucherid)) return "''"; return "'" + l.cvoucherid + "'"; }).ToList<string>().Where(lo => lo != "''").ToArray());

            if (keys == string.Empty || keys == "")
            {
                keys = "''";
            }
            if (cvoucherids == string.Empty || cvoucherids == "")
            {
                cvoucherids = "''";
            }
            strTempSQL = "select cvoucherkey+'|'+cvoucherid as keycode,cvoucherkey,cvoucherid from  t_gys_log where cvoucherkey in(" + keys + ") and cvoucherid in ("
                + cvoucherids + ")";

            var tempDt = SqlHelper.GetDataTable(strTempSQL);



            if (tempDt == null||tempDt.Rows.Count==1)
            {
                for (int i = 0; i < listLogs.Count; i++)
                {
                    var log = listLogs[i];
                    strSQL = "INSERT INTO t_gys_log(cvoucherid,cvoucherkey,sourceCode,result,date,[message],"
                + " xtresult,xtdate,xtmessage,cmemo,xttype,startTime,endTime,GysCode,guazhangqijian) "
                + " Values(@cvoucherid" + i + ",@cvoucherkey" + i + ",@sourceCode" + i + " ,@result" + i + ",@date" + i + ",@message" + i + ","
                + " @xtresult" + i + ",@xtdate" + i + ",@xtmessage" + i + ",@cmemo" + i + ",@xttype" + i + ",@startTime" + i + ",@endTime" + i + ",@GysCode" + i + ",@guazhangqijian" + i + ")";
                    sbSql.Append(strSQL);
                }
            }
            else
            {
                List<string> listkeyC = new List<string>();

                for (int i = 0; i < tempDt.Rows.Count; i++)
                {

                    listkeyC.Add(tempDt.Rows[i]["keycode"] == null ? "" : tempDt.Rows[i]["keycode"].ToString());

                }

                for (int i = 0; i < listLogs.Count; i++)
                {
                    var log = listLogs[i];

                    string key = string.IsNullOrEmpty(log.cvoucherkey) ? "" : log.cvoucherkey;
                    string code = string.IsNullOrEmpty(log.sourceCode) ? "" : log.sourceCode;

                    string keyCode = key + "|" + code;


                    if (listkeyC.Contains(keyCode))
                    {

                        strSQL = " UPDATE  t_gys_log SET [result]=@result" + i + ", "
                    + "[sourceCode]=@sourceCode" + i + ",[xtdate]=@xtdate" + i + " ,"
                    + "[date]=@date" + i + ",[xtmessage]=@message" + i + ","
                    + "[xtresult]=@xtresult" + i + ",[message]=@message" + i + ",[cmemo]=@cmemo" + i + ",[xttype]=@xttype" + i + "  where"
                    + " cvoucherkey=@cvoucherkey" + i + " and cvoucherid=@cvoucherid" + i + "";

                    }
                    else
                    {
                        
                        strSQL = "INSERT INTO t_gys_log(cvoucherid,cvoucherkey,sourceCode,result,date,[message],"
                + " xtresult,xtdate,xtmessage,cmemo,xttype,startTime,endTime,GysCode,guazhangqijian) "
                + " Values(@cvoucherid" + i + ",@cvoucherkey" + i + ",@sourceCode" + i + " ,@result" + i + ",@date" + i + ",@message" + i + ","
                + " @xtresult" + i + ",@xtdate" + i + ",@xtmessage" + i + ",@cmemo" + i + ",@xttype" + i + ",@startTime" + i + ",@endTime" + i + ",@GysCode" + i + ",@guazhangqijian" + i + ")";
                    }
                    sbSql.Append(strSQL);
                }
            }
            if(sbSql.Length>0&& (paras != null && paras.Count > 0))
            SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, sbSql.ToString(), paras.ToArray());
            //写明细日志
            if (sbDetail.Length > 0 && (paras != null && paras.Count > 0))
                SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, sbDetail.ToString(), paras.ToArray());
            //写日志     
        }

       
        /// 最长只取1000
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public static string Substr(string str)
        {
            string strReturn;
            if (str.ToString().Length > 1000)
            {
                strReturn = str.ToString().Substring(0, 1000);
            }
            else
            {
                strReturn = str.ToString();
            }
            return strReturn;
        }
    }
}
 
