﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Windows.Forms;

namespace UFIDA.U8.Portal.GuaZhangQueR
{
    public class CopyWebService
    {
        public string KaiPiaoTzdAdd(string qijian, string startTime, string endTime, string str, out List<clsGuaZhang> listCls, out List<clsGuaZhang> listFails)
        {
            string strjson = "";
            string ptMessage = "";
            string strMsg = "";
            listCls = null;
            string catchGys = "";
            List<string> listGysCodes = null;
            List<ClsLog> listLogIfGys = null;
            List<string> listGysCodes2 = null;
            List<ClsLog> listLogIfGys2 = null;
            List<ClsLog> listLogs = new List<ClsLog>();
            listFails = new List<clsGuaZhang>();
            bool hasFail = false;

            int type = -1;

            if (str == "")
            {
                type = 1;
            }
            else
            {
                string sql = "select cVenDefine1 from vendor where cVenCode='" + str + "'";

                var gzfsDt = SqlHelper.GetDataTable(sql);

                if (gzfsDt != null && gzfsDt.Rows.Count > 0)
                {
                    var gzfs = ValidateCol(gzfsDt.Rows[0][0]);

                    if ("用量挂账" != gzfs)
                    {
                        type = 3;
                    }
                    else
                    {
                        type = 2;
                    }
                }

            }


            DataTable dt = null;
            SqlParameter[] param = new SqlParameter[3];
            param[0] = new SqlParameter("@strdate", SqlDbType.VarChar, 10);
            param[1] = new SqlParameter("@enddate", SqlDbType.VarChar, 10);
            param[2] = new SqlParameter("@cvencode", SqlDbType.NVarChar, 60);

            param[0].Direction = ParameterDirection.Input;
            param[1].Direction = ParameterDirection.Input;
            param[2].Direction = ParameterDirection.Input;

            param[0].Value = startTime;
            param[1].Value = endTime;
            param[2].Value = str;


            DataTable dt2 = null;
            SqlParameter[] param2 = new SqlParameter[4];
            param2[0] = new SqlParameter("@strdate", SqlDbType.VarChar, 10);
            param2[1] = new SqlParameter("@enddate", SqlDbType.VarChar, 10);
            param2[2] = new SqlParameter("@cvencode", SqlDbType.NVarChar, 200);
            param2[3] = new SqlParameter("@cflag", SqlDbType.VarChar, 20);
            param2[0].Direction = ParameterDirection.Input;
            param2[1].Direction = ParameterDirection.Input;
            param2[2].Direction = ParameterDirection.Input;
            param2[3].Direction = ParameterDirection.Input;

            param2[0].Value = startTime;
            param2[1].Value = endTime;
            param2[2].Value = str;
            param2[3].Value = "是";
            //供应商不为空
            if (str != "")
            {
                string sql = "select xttype  from t_gys_log where GysCode='{0}'and guazhangqijian='{1}'";

                sql = string.Format(sql, str, qijian);

                var tempDt = SqlHelper.GetDataTable(sql);

                string xttype = "";

                if (tempDt != null && tempDt.Rows.Count > 0)
                {
                    xttype = ValidateCol(tempDt.Rows[0][0]);
                }

                if (xttype == "已生成")
                {
                    MessageBox.Show("该供应商在该期间已生成了挂账单!\r\n如需重新生成，请点击‘删除已上传的挂账通知’按钮");
                    return "";
                }

            }
            if (type == 1 || type == 2)
            {
                dt = SqlHelper.ProcGetDataTables("[p_gys_gztz]", param);
                if (type == 1)
                {
                    dt2 = SqlHelper.ProcGetDataTables("[p_gys_cgrk]", param2);
                }

            }
            else if (type == 3)
            {
                dt2 = SqlHelper.ProcGetDataTables("[p_gys_cgrk]", param2);
            }


            //挂账明细
            string mingxiSql = "";
            string mingxiSql2 = "";
            if (type == 1 || type == 2)
            {
                mingxiSql = "select * from v_gys_gzddetail where ddate between '" + startTime + "' and '" + endTime + "'";

                if (type == 2)
                {

                    mingxiSql += "and 供应商编码='" + str + "'";

                }
                else
                {
                    mingxiSql2 = "select * from v_gys_ptgzddetail where ddate between '" + startTime + "' and '" + endTime + "'";
                }
            }
            else
            {
                mingxiSql2 = "select * from v_gys_ptgzddetail where ddate between '" + startTime + "' and '" + endTime + "'" + " and 供应商编码='" + str + "'";
            }
            DataTable mxDt = null;
            DataTable mxDt2 = null;

            if (mingxiSql != "")
            {
                mxDt = SqlHelper.GetDataTable(mingxiSql);
            }
            if (mingxiSql2 != "")
            {
                mxDt2 = SqlHelper.GetDataTable(mingxiSql2);
            }
            listCls = new List<clsGuaZhang>();
            try
            {
                var list1 = GetGuaZhang(dt, mxDt, qijian, out listGysCodes, out listLogIfGys, str);
                var list2 = GetGuaZhang(dt2, mxDt2, qijian, out listGysCodes2, out listLogIfGys2, str);

                if (list1 == null && list2 == null)
                {
                    return "";
                }



                if (list1 != null && list1.Count > 0)
                {
                    listCls.AddRange(list1);
                }
                if (list2 != null && list2.Count > 0)
                {
                    listCls.AddRange(list2);
                }

                if (listGysCodes == null)
                {
                    listGysCodes = new List<string>();
                }
                if (listLogIfGys == null)
                {
                    listLogIfGys = new List<ClsLog>();
                }
                if (listGysCodes2 != null && listGysCodes2.Count > 0)
                {
                    listGysCodes.AddRange(listGysCodes2);
                }
                if (listLogIfGys2 != null && listLogIfGys2.Count > 0)
                {
                    listLogIfGys.AddRange(listLogIfGys2);
                }


                List<string> listIds = new List<string>();

                for (int i = 0; i < listCls.Count; i++)
                {
                    ClsLog log = new ClsLog();
                    try
                    {
                        log.cvoucherkey = "70";
                        log.sourceCode = listCls[i].gongyingshang;
                        log.cmemo = "新增协同";
                        log.cmemo = log.cmemo + ",U8修改是否协同成功";
                        log.startTime = startTime;
                        log.endTime = endTime;
                        log.guazhangqijian = qijian;
                        log.GysCode = log.sourceCode;
                        catchGys = log.sourceCode;
                        List<dynamic> lists = new List<dynamic>();


                        lists.Add(new { name = "MisAutoUdb_Add", type = "add", param = listCls[i] });

                        strjson = JsonConvert.SerializeObject(new { institutionid = "30497e4cd5445645634897cb70e1", @object = lists });

                        strMsg = PostXieTong(strjson, GetApiStr("1004"));

                        string getId = "-1";

                        if (strMsg.Contains("serialnumber"))
                        {
                            clsSuccessJson listRetJson = JsonConvert.DeserializeObject<clsSuccessJson>(strMsg);

                            if (listRetJson != null)
                            {
                                if (listRetJson != null && listRetJson.@object.Count > 0)
                                {
                                    var d = listRetJson.@object[0];

                                    if (d.data != null)
                                    {
                                        var ddd = d.data;

                                        if (ddd.code == 200)
                                        {
                                            listIds.Add(ddd.id);
                                            getId = ddd.id;
                                            log.result = "1";
                                            log.xttype = "已生成";
                                            log.xtresult = log.result;
                                        }
                                        else
                                        {

                                            var index = listRetJson.@object.IndexOf(d);

                                            listFails.Add(listCls[index]);

                                            log.result = "0";
                                            log.xttype = "生成失败";
                                            log.xtresult = log.result;
                                            log.message = "GysCode:" + listCls[index].gongyingshang + "\r\n message:" + ddd.message + "\r\n";

                                            ptMessage += log.message;
                                            listIds.Add("-1");
                                        }
                                    }

                                }
                            }
                        }
                        else
                        {
                            log.result = "0";
                            log.xtresult = log.result;
                            log.xttype = "生成失败";
                            log.message = "供应商:" + listCls[i].gongyingshang + "服务器返回异常:" + strMsg;
                            listIds.Add("-1");
                            ptMessage += log.message;
                            listFails.Add(listCls[i]);
                        }
                        log.cvoucherid = getId;

                    }
                    catch (Exception ex)
                    {
                        log.cmemo = "新增协同失败";
                        log.xttype = "生成失败";
                        log.result = "0";
                        log.xtresult = "0";
                        log.message = "方法“KaiPiaoTzdAdd()” 报错" + ex.Message.ToString();
                        listFails.Add(listCls[i]);
                    }
                    finally
                    {
                        ClsSynchroData.WriteSqlLog(log);
                    }
                }

            }

            catch (Exception ex)
            {
                ClsLog log = new ClsLog();
                log.startTime = startTime;
                log.endTime = endTime;
                log.guazhangqijian = qijian;
                log.cvoucherkey = "70";
                log.sourceCode = catchGys;
                log.cmemo = "新增协同失败";
                log.xttype = "生成失败";
                log.result = "0";
                log.xtresult = "0";
                log.message = "方法“KaiPiaoTzdAdd()” 报错" + ex.Message.ToString();
                ClsSynchroData.WriteSqlLog(log);
                hasFail = true;
                return "-1";
            }
            if (ptMessage != "")
            {
                MessageBox.Show(ptMessage);
                return "";
            }
            else
            {
                return "200";
            }

        }

        public string GuaZhangLogAdd(string qijian, string startTime, string endTime, List<string> lGyss, out List<clsGuaZhang> listFails)
        {
            string str = "";//表示全部供应商
            string strjson = "";
            string ptMessage = "";
            string strMsg = "";
            bool hasFail = false;
            string catchGys = "";
            List<clsGuaZhang> listCls = null;
            List<string> listGysCodes = null;
            List<ClsLog> listLogIfGys = null;
            List<string> listGysCodes2 = null;
            List<ClsLog> listLogIfGys2 = null;
            List<ClsLog> listLogs = new List<ClsLog>();
            listFails = new List<clsGuaZhang>();
            int type = -1;

            DataTable dt=null;
            SqlParameter[] param = new SqlParameter[3];
            param[0] = new SqlParameter("@strdate", SqlDbType.VarChar, 10);
            param[1] = new SqlParameter("@enddate", SqlDbType.VarChar, 10);
            param[2] = new SqlParameter("@cvencode", SqlDbType.NVarChar, 60);

            param[0].Direction = ParameterDirection.Input;
            param[1].Direction = ParameterDirection.Input;
            param[2].Direction = ParameterDirection.Input;

            param[0].Value = startTime;
            param[1].Value = endTime;
            param[2].Value = str;


            DataTable dt2 = null;
            SqlParameter[] param2 = new SqlParameter[4];
            param2[0] = new SqlParameter("@strdate", SqlDbType.VarChar, 10);
            param2[1] = new SqlParameter("@enddate", SqlDbType.VarChar, 10);
            param2[2] = new SqlParameter("@cvencode", SqlDbType.NVarChar, 200);
            param2[3] = new SqlParameter("@cflag", SqlDbType.VarChar, 20);
            param2[0].Direction = ParameterDirection.Input;
            param2[1].Direction = ParameterDirection.Input;
            param2[2].Direction = ParameterDirection.Input;
            param2[3].Direction = ParameterDirection.Input;

            param2[0].Value = startTime;
            param2[1].Value = endTime;
            param2[2].Value = str;
            param2[3].Value = "是";
            //供应商不为空
            if (str != "")
            {
                string sql = "select xttype  from t_gys_log where GysCode='{0}'and guazhangqijian='{1}'";

                sql = string.Format(sql, str, qijian);

                var tempDt = SqlHelper.GetDataTable(sql);

                string xttype = "";

                if (tempDt != null && tempDt.Rows.Count > 0)
                {
                    xttype = ValidateCol(tempDt.Rows[0][0]);
                }

                if (xttype == "已生成")
                {
                    MessageBox.Show("该供应商在该期间已生成了挂账单!\r\n如需重新生成，请点击‘删除已上传的挂账通知’按钮");
                    return "";
                }

            }
            if (type == 1 || type == 2)
            {
                dt = SqlHelper.ProcGetDataTables("[p_gys_gztz]", param);
                if (type == 1)
                {
                    dt2 = SqlHelper.ProcGetDataTables("[p_gys_cgrk]", param2);
                }

            }
            else if (type == 3)
            {
                dt2 = SqlHelper.ProcGetDataTables("[p_gys_cgrk]", param2);
            }


            //挂账明细
            string mingxiSql = "";
            string mingxiSql2 = "";
            if (type == 1 || type == 2)
            {
                mingxiSql = "select * from v_gys_gzddetail where ddate between '" + startTime + "' and '" + endTime + "'";

                if (type == 2)
                {

                    mingxiSql += "and 供应商编码='" + str + "'";

                }
                else
                {
                    mingxiSql2 = "select * from v_gys_ptgzddetail where ddate between '" + startTime + "' and '" + endTime + "'";
                }
            }
            else
            {
                mingxiSql2 = "select * from v_gys_ptgzddetail where ddate between '" + startTime + "' and '" + endTime + "'" + " and 供应商编码='" + str + "'";
            }
            DataTable mxDt = null;
            DataTable mxDt2 = null;

            if (mingxiSql != "")
            {
                mxDt = SqlHelper.GetDataTable(mingxiSql);
            }
            if (mingxiSql2 != "")
            {
                mxDt2 = SqlHelper.GetDataTable(mingxiSql2);
            }
            listCls = new List<clsGuaZhang>();
            try
            {
                var list1 = GetGuaZhang(dt, mxDt, qijian, out listGysCodes, out listLogIfGys, str);
                var list2 = GetGuaZhang(dt2, mxDt2, qijian, out listGysCodes2, out listLogIfGys2, str);

                if (list1 == null && list2 == null)
                {
                    return "";
                }

                if (list1 != null && list1.Count > 0)
                {
                    listCls.AddRange(list1);
                }
                if (list2 != null && list2.Count > 0)
                {
                    listCls.AddRange(list2);
                }

                if (listGysCodes == null)
                {
                    listGysCodes = new List<string>();
                }
                if (listLogIfGys == null)
                {
                    listLogIfGys = new List<ClsLog>();
                }
                if (listGysCodes2 != null && listGysCodes2.Count > 0)
                {
                    listGysCodes.AddRange(listGysCodes2);
                }
                if (listLogIfGys2 != null && listLogIfGys2.Count > 0)
                {
                    listLogIfGys.AddRange(listLogIfGys2);
                }


                List<string> listIds = new List<string>();

                for (int i = 0; i < listCls.Count; i++)
                {
                    ClsLog log = new ClsLog();
                    try
                    {

                        log.cvoucherkey = "70";
                        log.sourceCode = listCls[i].gongyingshang;
                        log.cmemo = "新增协同";
                        log.cmemo = log.cmemo + ",U8修改是否协同成功";
                        log.startTime = startTime;
                        log.endTime = endTime;
                        log.guazhangqijian = qijian;
                        log.GysCode = log.sourceCode;
                        catchGys = log.sourceCode;
                        //过滤选择的供应商
                        listCls = listCls.Where(l => lGyss.Contains(l.gongyingshang)).ToList();


                        List<dynamic> lists = new List<dynamic>();


                        lists.Add(new { name = "MisAutoUdb_Add", type = "add", param = listCls[i] });

                        strjson = JsonConvert.SerializeObject(new { institutionid = "30497e4cd5445645634897cb70e1", @object = lists });

                        strMsg = PostXieTong(strjson, GetApiStr("1004"));
                        string getId = "-1";

                        if (strMsg.Contains("serialnumber"))
                        {
                            clsSuccessJson listRetJson = JsonConvert.DeserializeObject<clsSuccessJson>(strMsg);

                            if (listRetJson != null)
                            {
                                if (listRetJson != null && listRetJson.@object.Count > 0)
                                {
                                    var d = listRetJson.@object[0];

                                    if (d.data != null)
                                    {
                                        var ddd = d.data;

                                        if (ddd.code == 200)
                                        {
                                            listIds.Add(ddd.id);
                                            getId = ddd.id;
                                            log.result = "1";
                                            log.xttype = "已生成";
                                            log.xtresult = log.result;
                                        }
                                        else
                                        {
                                            var index = listRetJson.@object.IndexOf(d);

                                            log.result = "0";
                                            log.xttype = "生成失败";
                                            log.xtresult = log.result;
                                            log.message = "GysCode:" + listCls[index].gongyingshang + "\r\n message:" + ddd.message + "\r\n";
                                            listFails.Add(listCls[index]);
                                            ptMessage += log.message;
                                            listIds.Add("-1");
                                        }
                                    }

                                }
                            }
                        }
                        else
                        {
                            log.result = "0";
                            log.xtresult = log.result;
                            log.xttype = "生成失败";
                            log.message = "供应商:" + listCls[i].gongyingshang + "服务器返回异常:" + strMsg;
                            listIds.Add("-1");
                            ptMessage += log.message;
                            listFails.Add(listCls[i]);
                        }
                        log.cvoucherid = getId;

                    }
                    catch (Exception ex)
                    {

                        log.sourceCode = catchGys;
                        log.cmemo = "新增协同失败";
                        log.xttype = "生成失败";
                        log.result = "0";
                        log.xtresult = "0";
                        log.message = "方法“GuaZhangLogAdd()” 报错" + ex.Message.ToString();
                        listFails.Add(listCls[i]);
                    }
                    finally
                    {
                        ClsSynchroData.WriteSqlLog(log);

                    }
                }
            }

            catch (Exception ex)
            {
                ClsLog log = new ClsLog();
                log.startTime = startTime;
                log.endTime = endTime;
                log.guazhangqijian = qijian;
                log.cvoucherkey = "70";
                log.sourceCode = catchGys;
                log.xttype = "生成失败";
                log.cmemo = "新增协同失败";
                log.result = "0";
                log.xtresult = "0";
                log.message = "方法“GuaZhangLogAdd()” 报错" + ex.Message.ToString();
                ClsSynchroData.WriteSqlLog(log);
                hasFail = true;
                return "-1";
            }
            finally
            {


            }
            if (ptMessage != "")
            {
                MessageBox.Show(ptMessage);
                return "";
            }
            else
            {
                return "200";
            }

        }

        public string ReUpLoad(List<clsGuaZhang> listCls, out List<clsGuaZhang> listFails)
        {
            string msg = "";
            listFails = new List<clsGuaZhang>();
            for (int i = 0; i < listCls.Count; i++)
            {
                ClsLog log = new ClsLog();

                try
                {


                    log.cvoucherkey = "70";
                    log.sourceCode = listCls[i].gongyingshang;
                    log.cmemo = "新增协同";
                    log.cmemo = log.cmemo + ",U8修改是否协同成功";
                    log.startTime = listCls[i].riqi;
                    log.endTime = listCls[i].jiezhiriqi;
                    log.guazhangqijian = listCls[i].guazhangqijian;
                    log.GysCode = log.sourceCode;

                    List<dynamic> lists = new List<dynamic>();


                    lists.Add(new { name = "MisAutoUdb_Add", type = "add", param = listCls[i] });

                    string strjson = JsonConvert.SerializeObject(new { institutionid = "30497e4cd5445645634897cb70e1", @object = lists });

                    string strMsg = PostXieTong(strjson, GetApiStr("1004"));

                    string getId = "-1";

                    if (strMsg.Contains("serialnumber"))
                    {
                        clsSuccessJson listRetJson = JsonConvert.DeserializeObject<clsSuccessJson>(strMsg);

                        if (listRetJson != null)
                        {
                            if (listRetJson != null && listRetJson.@object.Count > 0)
                            {
                                var d = listRetJson.@object[0];

                                if (d.data != null)
                                {
                                    var ddd = d.data;

                                    if (ddd.code == 200)
                                    {

                                        log.result = "1";
                                        log.xttype = "已生成";
                                        log.xtresult = log.result;
                                        getId = ddd.id;
                                    }
                                    else
                                    {
                                        var index = listRetJson.@object.IndexOf(d);
                                        listFails.Add(listCls[index]);
                                        log.result = "0";
                                        log.xttype = "生成失败";
                                        log.xtresult = log.result;
                                        log.message = "GysCode:" + listCls[index].gongyingshang + "\r\n message:" + ddd.message + "\r\n";

                                        msg += log.message;
                                    }
                                }

                            }
                        }
                    }
                    else
                    {
                        log.result = "0";
                        log.xtresult = log.result;
                        log.xttype = "生成失败";
                        log.message = "供应商:" + listCls[i].gongyingshang + "服务器返回异常:" + strMsg;
                        msg += log.message;
                        listFails.Add(listCls[i]);
                    }
                    log.cvoucherid = getId;

                }
                catch (Exception ex)
                {
                    log.cmemo = "新增协同失败";
                    log.result = "0";
                    log.xtresult = "0";
                    log.xttype = "生成失败";
                    log.message = "方法“KaiPiaoTzdAdd()” 报错" + ex.Message.ToString();
                    listFails.Add(listCls[i]);
                }
                finally
                {
                    ClsSynchroData.WriteSqlLog(log);
                }
            }
            return msg;
        }

        public string NewGuaZhangDelete(string qijian, string startTime, string endTime, string str, out List<string> allGys, out string showMsg)
        {
            string strjson = "";
            string strMsg = "";
            showMsg = "";
            allGys = new List<string>();
            List<string> delGys = new List<string>();
            bool hasFail = false;
            string msg = "";
            string delMsg = "";
            try
            {
                if (str == "")
                {
                    DataTable dt;
                    SqlParameter[] param = new SqlParameter[3];
                    param[0] = new SqlParameter("@strdate", SqlDbType.VarChar, 10);
                    param[1] = new SqlParameter("@enddate", SqlDbType.VarChar, 10);
                    param[2] = new SqlParameter("@cvencode", SqlDbType.NVarChar, 60);

                    param[0].Direction = ParameterDirection.Input;
                    param[1].Direction = ParameterDirection.Input;
                    param[2].Direction = ParameterDirection.Input;

                    param[0].Value = startTime;
                    param[1].Value = endTime;
                    param[2].Value = str;
                    dt = SqlHelper.ProcGetDataTables("[p_gys_gztz]", param);

                    List<clsGuaZhang> listCls = new List<clsGuaZhang>();

                    if (dt != null && dt.Rows.Count > 0)
                    {
                        for (int j = 0; j < dt.Rows.Count; j++)
                        {
                            if (listCls.Where(p => p.gongyingshang == ValidateCol(dt.Rows[j]["供应商编码"])).Count() > 0)
                            {
                                continue;
                            }
                            clsGuaZhang gz = new clsGuaZhang();
                            gz.gongyingshang = ValidateCol(dt.Rows[j]["供应商编码"]);
                            listCls.Add(gz);
                        }
                    }

                    allGys = listCls.Select(l => l.gongyingshang).ToList();

                }
                else
                {
                    allGys.Add(str);
                }
                List<ClsLog> listLogIfGys = new List<ClsLog>();

                if (allGys != null && allGys.Count > 0)
                {


                    string fmt2 = "'{0}'";
                    string gysCodes = string.Join(",", allGys.Select(l => string.Format(fmt2, l)).ToArray());

                    string sql2 = "select *  from t_gys_log where GysCode in (" + gysCodes + ") and guazhangqijian='" + qijian + "' and xttype='已生成'";

                    var tempDt2 = SqlHelper.GetDataTable(sql2);

                    if (tempDt2 != null && tempDt2.Rows.Count > 0)
                    {
                        for (int i = 0; i < tempDt2.Rows.Count; i++)
                        {
                            ClsLog log = new ClsLog();

                            log.xttype = ValidateCol(tempDt2.Rows[i]["xttype"]);
                            log.GysCode = ValidateCol(tempDt2.Rows[i]["GysCode"]);
                            log.sourceCode = ValidateCol(tempDt2.Rows[i]["sourceCode"]);
                            log.guazhangqijian = ValidateCol(tempDt2.Rows[i]["guazhangqijian"]);
                            log.cvoucherid = ValidateCol(tempDt2.Rows[i]["cvoucherid"]);
                            log.cvoucherkey = ValidateCol(tempDt2.Rows[i]["cvoucherkey"]);

                            listLogIfGys.Add(log);
                        }
                    }

                    if (listLogIfGys != null && listLogIfGys.Count > 0)
                    {

                        foreach (var l in listLogIfGys)
                        {
                            if (l.xttype == "已生成")
                            {
                                delGys.Add(l.GysCode);
                            }
                        }

                    }
                }
                List<string> cDelGys = null;//可以删除的供应商
                List<string> cantDelGys = null;//不可以删除的供应商
                string gzTzds = "";//需要联系供应商删除的orderno单号
                if (delGys == null || delGys.Count == 0)
                {
                    showMsg = "没有可供删除的数据";
                    MessageBox.Show(showMsg);
                    return "";


                }
                //在开票通知里查询，是否有已经出单得开票通知单，如果有，就不能删除，如果没有就可以删除。
                List<dynamic> lists = new List<dynamic>();
                List<dynamic> lists2 = new List<dynamic>();

                string gysConditon = "({0})";
                string ff = "'{0}'";

                string codes = string.Join(",", delGys.Select(l => string.Format(ff, l)).ToArray());

                gysConditon = string.Format(gysConditon, codes);

                string gzqj = string.Format(ff, qijian);


                lists2.Add(new { compare = "and", filtername = "guazhangqijian", @operator = "=", value = gzqj });
                lists2.Add(new { compare = "and", filtername = "isVoid", @operator = "=", value = "0" });
                lists2.Add(new { compare = "and", filtername = "gongyingshangbianma", @operator = "in", value = gysConditon });
                //MisAutoAst_Select 开票确认
                //MisAutoPxq_Select 开票通知
                lists.Add(new { name = "MisAutoAst_Select", type = "select", param = lists2 });

                strjson = JsonConvert.SerializeObject(new { institutionid = "30497e4cd5445645634897cb70e1", @object = lists });
                strMsg = PostXieTong(strjson, GetApiStr("1005"));


                clsRoot<clsKaiPiaoSelect> listretDd = JsonConvert.DeserializeObject<clsRoot<clsKaiPiaoSelect>>(strMsg);

                List<clsKaiPiaoSelect> listObj = null;
                int selCode = 0;
                string selMsg = "";
                if (listretDd != null && listretDd.@object != null
                       && listretDd.@object.Count > 0)
                {

                    var d1 = listretDd.@object[0];

                    if (d1.data != null)
                    {
                        listObj = d1.data.data;
                        selCode = d1.data.code;
                        selMsg = d1.data.message;
                    }

                }


                if (listObj != null && listObj.Count > 0)
                {

                    List<string> cantDel = listObj.Select(l => l.gongyingshangbianma).ToList();
                    gzTzds = string.Join(",", listObj.Select(l => l.orderno).ToArray());

                    cantDelGys = delGys.Intersect(cantDel).ToList();
                    if (cantDelGys != null)
                        cDelGys = delGys.Except(cantDelGys).ToList();


                    //MisAutoPxq_Update
                    //把开票通知单的状态设置未可删除

                    List<dynamic> lists4 = new List<dynamic>();


                    foreach (var item in listObj)
                    {
                        item.operateid = "0";
                        item.auditState = "0";
                    }
                    // MisAutoAst_Update开票确认单
                    //MisAutoPxq_Update开票通知单
                    for (int i = 0; i < listObj.Count; i++)
                    {
                        lists4.Add(new { name = "MisAutoAst_Update", type = "update", param = listObj[i] });
                    }
                    strjson = JsonConvert.SerializeObject(new { institutionid = "30497e4cd5445645634897cb70e1", @object = lists4 });

                    strMsg = PostXieTong(strjson, GetApiStr("1004"));

                    clsSuccessJson listRetJson = JsonConvert.DeserializeObject<clsSuccessJson>(strMsg);

                }
                else
                {
                    cDelGys = delGys;
                }


                int trueDelCount = 0;
                string deled = "";
                int delCount = 0;
                string notDel = "";
                string trueNotDel = "";
                int notDelCount = 0;
                int trueNotDelCount = 0;
                //需要联系供应商删除的条数
                int cantDelCount = 0;
                string cantDelStr = "";
                if (listObj != null && listObj.Count > 0)
                {
                    cantDelCount = listObj.Count;
                    cantDelStr = string.Join(" ", listObj.Select(l => l.gongyingshangbianma).ToArray());
                }

                List<ClsLog> listDelLogs = new List<ClsLog>();
                //删除
                if (cDelGys != null && cDelGys.Count > 0)
                {
                    foreach (var strGys in cDelGys)
                    {
                        var log = listLogIfGys.Find(l => l.GysCode == strGys);
                        if (log != null)
                        {
                            listDelLogs.Add(log);
                        }
                    }
                }

                if (listDelLogs.Count > 0)
                {

                    List<dynamic> lists3 = new List<dynamic>();
                    List<dynamic> listCls2 = new List<dynamic>();

                    for (int i = 0; i < listDelLogs.Count; i++)
                    {
                        listCls2.Add(new { id = listDelLogs[i].cvoucherid });
                    }

                    for (int i = 0; i < listCls2.Count; i++)
                    {
                        lists3.Add(new { name = "MisAutoUdb_Delete", type = "delete", param = listCls2[i] });
                    }
                    strjson = JsonConvert.SerializeObject(new { institutionid = "30497e4cd5445645634897cb70e1", @object = lists3 });
                    strMsg = PostXieTong(strjson, GetApiStr("1004"));

                    clsSuccessJson retJson = JsonConvert.DeserializeObject<clsSuccessJson>(strMsg);



                    StringBuilder sb = new StringBuilder();
                    string sql = "update t_gys_log set xttype='已删除' where cvoucherkey='70' and cvoucherid='{0}'\r\n";

                    if (retJson != null && retJson.@object != null && retJson.@object.Count > 0)
                    {
                        for (int i = 0; i < retJson.@object.Count; i++)
                        {
                            var dd = retJson.@object[i].data;

                            if (dd.code == 200)
                            {
                                sb.Append(string.Format(sql, dd.id));
                                deled += listDelLogs[i].GysCode + " ";
                                trueDelCount += 1;

                            }
                            else
                            {
                                trueNotDel += listDelLogs[i].GysCode + " ";
                                trueNotDelCount += 1;
                                delMsg += "供应商平台id为:" + listDelLogs[i].cvoucherid + "供应商编码为:" + listDelLogs[i].GysCode + "删除失败。\r\n" + dd.message + "\r\n";
                            }
                        }
                    }

                    if (trueDelCount > 0)
                    {
                        SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, sb.ToString());
                    }
                    else if (trueDelCount != listDelLogs.Count)//平台的删除和可删除数量不等说明日志表和平台的记录的id不对等，有可能日志表记录的id，平台没有。
                    {
                        showMsg = "在日志表中查询到数据，可是无法在供应商平台删除该数据。\r\n请检查日志表的数据是否在供应商平台存在.\r\n错误消息：" + delMsg;
                        MessageBox.Show(showMsg);
                    }
                }
                string mm = "请联系供应商更改后删除。";
                string delFmt = "一共有{0}条数据。\r\n已删除记录{1}条,供应商编码:{2},\r\n需要联系供应商删除的有{3}条,发票号:{4},\r\n删除失败{5}条,供应商编码:{6}";

                if (cDelGys != null && cDelGys.Count > 0)
                {

                    delCount = cDelGys.Count;
                }
                if (cantDelGys != null && cantDelGys.Count > 0)
                {
                    notDel = string.Join(" ", cantDelGys.ToArray());
                    notDelCount = cantDelGys.Count;

                }
                notDel += " " + trueNotDel;


                msg = string.Format(delFmt, delCount + notDelCount, trueDelCount, deled, cantDelCount, cantDelStr, trueNotDelCount, trueNotDel);

                showMsg = msg;


                if (notDelCount > 0)
                {
                    msg += mm;
                }
            }
            catch (Exception ex)
            {
                ClsLog log = new ClsLog();
                log.cvoucherkey = "70";
                log.cmemo = "删除协同";
                log.result = "0";
                log.xtresult = "0";
                log.message = "方法“NewGuaZhangDelete()” 报错" + ex.Message.ToString();
                ClsSynchroData.WriteSqlLog(log);
                hasFail = true;
                MessageBox.Show(log.message);
                return "-1";
            }
            finally
            {
                //if (!hasFail)
                //{
                //    ClsLog log = new ClsLog();
                //    log.cvoucherkey = "70";
                //    log.cmemo = "新增协同";
                //    log.result = "1";
                //    log.xtresult = "1";
                //    log.message = msg;
                //    ClsSynchroData.WriteSqlLog(log);
                //}
                if (msg != "")
                    MessageBox.Show(msg);
            }


            return strMsg;


        }

        private string GuaZhangDelete(List<string> ids, List<clsWhere> listWheres)
        {
            string strjson = "";
            string strMsg = "";


            List<dynamic> lists = new List<dynamic>();
            List<dynamic> listCls = new List<dynamic>();

            for (int i = 0; i < ids.Count; i++)
            {
                listCls.Add(new { id = ids[i] });
            }

            for (int i = 0; i < listCls.Count; i++)
            {
                lists.Add(new { name = "MisAutoUdb_Delete", type = "delete", param = listCls[i] });
            }
            strjson = JsonConvert.SerializeObject(new { institutionid = "30497e4cd5445645634897cb70e1", @object = lists });
            strMsg = PostXieTong(strjson, GetApiStr("1004"));

            StringBuilder sb = new StringBuilder();
            string sql = "update t_gys_log set xttype='已删除' where cvoucherkey='{0}' and cvoucherid='{1}'\r\n";

            for (int i = 0; i < listWheres.Count; i++)
            {
                sb.Append(string.Format(sql, listWheres[i].key, listWheres[i].id));

            }
            SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, sb.ToString());

            return strMsg;


        }

        private List<clsGuaZhang> GetGuaZhang(DataTable dt, DataTable mxDt, string qijian, out List<string> listGysCodes, out List<ClsLog> listLogIfGys, string str)
        {
            List<clsGuaZhang> listCls = new List<clsGuaZhang>();
            listGysCodes = null;
            listLogIfGys = null;
            if (dt == null || dt.Rows.Count <= 0)
            {
                MessageBox.Show("没有查询到数据");

                return null;
            }
            for (int j = 0; j < dt.Rows.Count; j++)
            {
                if (listCls.Where(p => p.gongyingshang == ValidateCol(dt.Rows[j]["供应商编码"])).Count() > 0)
                {
                    continue;
                }


                clsGuaZhang cls = new clsGuaZhang();
                cls.gongyingshangmingchen = ValidateCol(dt.Rows[j]["供应商名称"]);
                cls.guazhangqijian = qijian;//挂账期间
                cls.bumen = ValidateCol(dt.Rows[j]["部门"]);
                cls.caigouleixing = ValidateCol(dt.Rows[j]["采购类型"]);
                cls.gongyingshang = ValidateCol(dt.Rows[j]["供应商编码"]);

                cls.jiezhiriqi = ValidateCol(dt.Rows[j]["enddate"]);//截至日期
                cls.riqi = ValidateCol(dt.Rows[j]["strdate"]);//开始日期


                cls.yewuleixing = "";
                cls.yewuyuan = ValidateCol(dt.Rows[j]["业务员"]);//业务员

                cls.guazhangmingxi = new List<guazhangBody>();

                string filter = "供应商编码='" + ValidateCol(dt.Rows[j]["供应商编码"]) + "'";

                var huizRows = dt.Select(filter);

                cls.guazhanghuizong = new List<guazhangHuiZBody>();

                for (int m = 0; m < huizRows.Length; m++)
                {
                    guazhangHuiZBody hzBody = new guazhangHuiZBody();
                    hzBody.gongyingshangcunhuobianma = ValidateCol(huizRows[m]["供应商存货编码"]);
                    hzBody.gongyingshangcunhuomingchen = ValidateCol(huizRows[m]["供应商存货名称"]);
                    hzBody.benqiguazhangshuliang = ValidateCol(huizRows[m]["本期挂账数量"]);
                    hzBody.benqirukushuliang = ValidateCol(huizRows[m]["本期入库数量"]);
                    hzBody.benqishiyongshuliang = ValidateCol(huizRows[m]["本期使用数量"]);
                    hzBody.benqisunhaoshuliang = ValidateCol(huizRows[m]["本期损耗数量"]);
                    hzBody.benqituihuoshuliang = ValidateCol(huizRows[m]["本期退货数量"]);
                    hzBody.cunhuobianma = ValidateCol(huizRows[m]["存货编码"]);
                    hzBody.cunhuodaima = ValidateCol(huizRows[m]["存货代码"]);
                    hzBody.cunhuomingchen = ValidateCol(huizRows[m]["存货名称"]);
                    hzBody.danjia = ValidateCol(huizRows[m]["单价"]);
                    hzBody.danwei = ValidateCol(huizRows[m]["计量单位"]);
                    hzBody.guigexinghao = ValidateCol(huizRows[m]["规格型号"]);
                    hzBody.jine = ValidateCol(huizRows[m]["金额"]);
                    hzBody.qichushuliang = ValidateCol(huizRows[m]["期初数量"]);
                    hzBody.qimoshuliang = ValidateCol(huizRows[m]["期末数量"]);
                    hzBody.shuilv = ValidateCol(huizRows[m]["slv"]);
                    hzBody.wushuidanjia = ValidateCol(huizRows[m]["无税单价"]);
                    hzBody.wushuijine = ValidateCol(huizRows[m]["无税金额"]);

                    //更改二 编码
                    hzBody.fuzhudanwei = ValidateCol(huizRows[m]["辅助计量单位编码"]);
                    hzBody.qimofuzhushuliang = ValidateCol(huizRows[m]["期末辅助数量"]);
                    hzBody.benqisunhaofuzhushuliang = ValidateCol(huizRows[m]["本期损耗辅助数量"]);
                    hzBody.benqiguazhangfuzhushuliang = ValidateCol(huizRows[m]["本期挂账辅助数量"]);
                    hzBody.benqishiyongfuzhushuliang = ValidateCol(huizRows[m]["本期使用辅助数量"]);
                    hzBody.benqituihuofuzhushuliang = ValidateCol(huizRows[m]["本期退货辅助数量"]);
                    hzBody.benqirukufuzhushuliang = ValidateCol(huizRows[m]["本期入库辅助数量"]);
                    hzBody.qichufuzhushuliang = ValidateCol(huizRows[m]["期初辅助数量"]);

                    cls.guazhanghuizong.Add(hzBody);
                }

                listCls.Add(cls);
            }


            listGysCodes = listCls.Select(p => p.gongyingshang).ToList();

            if (str == "")
            {
                listLogIfGys = new List<ClsLog>();

                string fmt = "'{0}'";
                string gysCodes = string.Join(",", listGysCodes.Select(l => string.Format(fmt, l)).ToArray());

                string sql = "select *  from t_gys_log where GysCode in (" + gysCodes + ") and guazhangqijian='" + qijian + "' and xttype='已生成'";

                var tempDt2 = SqlHelper.GetDataTable(sql);

                if (tempDt2 != null && tempDt2.Rows.Count > 0)
                {
                    for (int i = 0; i < tempDt2.Rows.Count; i++)
                    {
                        ClsLog log = new ClsLog();

                        log.xttype = ValidateCol(tempDt2.Rows[i]["xttype"]);
                        log.GysCode = ValidateCol(tempDt2.Rows[i]["GysCode"]);
                        log.sourceCode = ValidateCol(tempDt2.Rows[i]["sourceCode"]);
                        log.guazhangqijian = ValidateCol(tempDt2.Rows[i]["guazhangqijian"]);
                        log.cvoucherid = ValidateCol(tempDt2.Rows[i]["cvoucherid"]);
                        log.cvoucherkey = ValidateCol(tempDt2.Rows[i]["cvoucherkey"]);

                        listLogIfGys.Add(log);
                    }
                }

                if (listLogIfGys != null && listLogIfGys.Count > 0)
                {

                    foreach (var l in listLogIfGys)
                    {
                        if (l.xttype == "已生成")
                        {
                            MessageBox.Show("全部供应商中有已生成的挂账通知单！\r\n如需重新生成,请点击请点击‘删除已上传的挂账通知’按钮");
                            return null;
                        }
                    }

                }

            }
            List<guazhangBody> listMxs = new List<guazhangBody>();

            if (mxDt != null || mxDt.Rows.Count > 0)
            {
                for (int i = 0; i < mxDt.Rows.Count; i++)
                {
                    guazhangBody mx = new guazhangBody();

                    mx.biaotibeizhu = ValidateCol(mxDt.Rows[i]["表体备注"]);
                    mx.cunhuobianma = ValidateCol(mxDt.Rows[i]["存货编码"]);
                    mx.cunhuomingchen = ValidateCol(mxDt.Rows[i]["存货名称"]);
                    mx.gongyingshang = ValidateCol(mxDt.Rows[i]["供应商编码"]);
                    mx.gongyingshangcunhuobianma = ValidateCol(mxDt.Rows[i]["供应商存货编码"]);//这里和供应商编码一样了
                    mx.guigexxinghao = ValidateCol(mxDt.Rows[i]["规格型号"]);
                    mx.jiliangdanweibianma = ValidateCol(mxDt.Rows[i]["计量单位编码"]);
                    mx.jiliangdanweimingchen = ValidateCol(mxDt.Rows[i]["计量单位名称"]);
                    mx.laiyuandanjuleixing = ValidateCol(mxDt.Rows[i]["来源单据类型"]);
                    mx.laiyuandanjuzhubiaoid = ValidateCol(mxDt.Rows[i]["来源单据主表id"]);
                    mx.laiyuandanjuzibiaoid = ValidateCol(mxDt.Rows[i]["来源单据子表id"]);
                    mx.pihao = ValidateCol(mxDt.Rows[i]["批号"]);
                    mx.shuilv = ValidateCol(mxDt.Rows[i]["税率"]);
                    mx.shuliang = ValidateCol(mxDt.Rows[i]["数量"]);
                    mx.weikaipiaoshuliang = ValidateCol(mxDt.Rows[i]["未开票数量"]);
                    mx.yikaipiaoshuliang = ValidateCol(mxDt.Rows[i]["已开票数量"]);
                    mx.yuanbihanshuidanjia = ValidateCol(mxDt.Rows[i]["原币含税单价"]);
                    mx.yuanbijiashuiheji = ValidateCol(mxDt.Rows[i]["原币价税合计"]);
                    mx.yuanbijine = ValidateCol(mxDt.Rows[i]["原币金额"]);
                    mx.yuanbishuie = ValidateCol(mxDt.Rows[i]["原币税额"]);
                    mx.yuanbiwushuidanjia = ValidateCol(mxDt.Rows[i]["原币无税单价"]);
                    mx.ziyouxiangba = ValidateCol(mxDt.Rows[i]["自由项八"]);
                    mx.ziyouxianger = ValidateCol(mxDt.Rows[i]["自由项二"]);
                    mx.ziyouxiangjiu = ValidateCol(mxDt.Rows[i]["自由项九"]);
                    mx.ziyouxiangliu = ValidateCol(mxDt.Rows[i]["自由项六"]);
                    mx.ziyouxiangqi = ValidateCol(mxDt.Rows[i]["自由项七"]);
                    mx.ziyouxiangsan = ValidateCol(mxDt.Rows[i]["自由项三"]);
                    mx.ziyouxiangshi = ValidateCol(mxDt.Rows[i]["自由项十"]);
                    mx.ziyouxiangsi = ValidateCol(mxDt.Rows[i]["自由项四"]);
                    mx.ziyouxiangwu = ValidateCol(mxDt.Rows[i]["自由项五"]);
                    mx.ziyouxiangyi = ValidateCol(mxDt.Rows[i]["自由项一"]);

                    //更改二 编码
                    mx.fuzhushuliang = ValidateCol(mxDt.Rows[i]["辅助数量"]);
                    mx.fuzhudanwei = ValidateCol(mxDt.Rows[i]["辅助单位"]);

                    listMxs.Add(mx);
                }

            }

            if (listMxs.Count > 0)
            {
                foreach (var zb in listCls)
                {
                    zb.guazhangmingxi = listMxs.Where(mx => mx.gongyingshang == zb.gongyingshang).ToList();
                }
            }
            return listCls;
        }

        private string ValidateCol(object obj)
        {
            if (obj == null)
            {
                return "";
            }
            else
            {
                return obj.ToString();
            }
        }

        public static string PostXieTong(string jsonStr, string strSendUrl)
        {

            string ret;
            HttpWebRequest request;

            //将SOAP字符串信息转换成Byte数组，用于后面的流传输  
            byte[] bytData = Encoding.UTF8.GetBytes(jsonStr.ToString());

            if (strSendUrl == "")
            {
                request = System.Net.WebRequest.Create(new Uri("http://39.98.50.22:8888/api.php/Public/NyDbInterface")) as HttpWebRequest;
            }
            else
            {
                request = System.Net.WebRequest.Create(new Uri(strSendUrl)) as HttpWebRequest;
            }

            request.Method = "POST";//POST方式传输  
            //request.Host = "localhost";//主机名或IP地址  
            request.ContentType = "text/json; charset=utf-8";//传输内容类型及编码格式  
            request.ContentLength = bytData.Length;//传输内容长度  

            request.Timeout = 10000000;//设置超时时间  
            //用GetRequestStream()方法来获取一个流，它发出的请求将数据发送到Internet资源供给接口  
            Stream newStream = request.GetRequestStream();
            //将数据写入该流  
            newStream.Write(bytData, 0, bytData.Length);//写入参数  
            newStream.Close();
            //服务响应  
            HttpWebResponse res;
            try
            {
                //获取一个响应  
                res = (HttpWebResponse)request.GetResponse();
            }
            catch (WebException ex)
            {
                res = (HttpWebResponse)ex.Response;
            }
            //将响应写入StreamReader  
            StreamReader sr = new StreamReader(res.GetResponseStream(), Encoding.UTF8);
            //读取流转换成字符串  
            ret = sr.ReadToEnd();
            //关闭资源  
            sr.Close();
            res.Close();
            newStream.Close();
            return ret;
        }

        private string GetApiStr(string ccode)
        {
            string api = string.Empty;

            string sql = "select url from t_gys_webservice where ccode='" + ccode + "'";

            var tb = SqlHelper.GetDataTable(sql);

            if (tb != null && tb.Rows.Count > 0)
            {
                api = ValidateCol(tb.Rows[0]["url"]);
            }

            if (api == string.Empty || api == "")
            {
                api = "http://39.98.50.22:8888/api.php/Public/NyDbInterface";
            }
            return api;

        }
    }
}
