﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using 测试dgv更新;
using System.IO;

namespace UFIDA.U8.Portal.GuaZhangQueR
{
    public partial class UCyj : UserControl
    {
        public static string DbConntion = null, User = null;
        DateTime curdate;

        private List<string> ListCode;
        private List<string> ListGys;
        private string GysCode = string.Empty;

        private List<string> ListCode1;
        private List<string> ListGys1;
        private string GysCode1 = string.Empty;

        private List<clsQiJian> ListQiJian = null;

        public DataTable DataTableUj { get; private set; }

        public List<clsUpdateRow> listupdates;

        int col1 = 0;
        int col2 = 1;

        int row = 0;
        int col = 0;

        DateTimePicker dtp = new DateTimePicker();  //这里实例化一个DateTimePicker控件
        Rectangle _Rectangle;
        public UCyj()
        {
            InitializeComponent();
            this.startTime.Value = DateTime.Now.AddMonths(-1);
            this.startTime.Format = DateTimePickerFormat.Custom;
            this.startTime.CustomFormat = "yyyy-MM-dd";
            this.endTime.Value = DateTime.Now;
            this.endTime.Format = DateTimePickerFormat.Custom;
            this.endTime.CustomFormat = "yyyy-MM-dd";


            SqlHelper.ConnectionString = "data source=127.0.0.1;initial catalog=UFDATA_006_2020;user id=sa;password=940619.lq;Connect Timeout=60;Persist Security Info=True ;Current Language=Simplified Chinese";
            ListCode = new List<string>();
            ListGys = new List<string>();
            ListCode1 = new List<string>();
            ListGys1 = new List<string>();
            listupdates = new List<clsUpdateRow>();
            InitGys();
            //InitQiJian();


            this.Load += UCyj_Load;
        }
        public UCyj(string dbconntion, string user, DateTime CurDate)
        {
            InitializeComponent();

            //----初始化控件数据
            this.startTime.Value = DateTime.Now.AddMonths(-1);
            this.startTime.Format = DateTimePickerFormat.Custom;
            this.startTime.CustomFormat = "yyyy-MM-dd";
            this.endTime.Value = DateTime.Now;
            this.endTime.Format = DateTimePickerFormat.Custom;
            this.endTime.CustomFormat = "yyyy-MM-dd";

            DbConntion = dbconntion.Substring(dbconntion.IndexOf(';') + 1);
            User = user;
            this.curdate = CurDate;
            SqlHelper.ConnectionString = DbConntion;
            ListCode = new List<string>();
            ListGys = new List<string>();
            ListCode1 = new List<string>();
            ListGys1 = new List<string>();
            InitGys();
            //InitQiJian();


            this.Load += UCyj_Load;
        }

        private void UCyj_Load(object sender, EventArgs e)
        {
            dgv_update.Controls.Add(dtp);  //把时间控件加入DataGridView
            dtp.Visible = false;  //先不让它显示
            dtp.Format = DateTimePickerFormat.Custom;  //设置日期格式为2010-08-05
            dtp.TextChanged += new EventHandler(dtp_TextChange); //
        }

        private void dtp_TextChange(object sender, EventArgs e)
        {
            dgv_update.CurrentCell.Value = dtp.Text.ToString();
        }

        private void InitGys()
        {
            string sql = "select cVenCode, cVenName from vendor";

            var dt = SqlHelper.GetDataTable(sql);

            if (dt == null || dt.Rows.Count == 0)
            {
                return;
            }
            ListCode.Add("");
            ListGys.Add("全部");
            CbGys.Items.Add("全部");

            ListCode1.Add("");
            ListGys1.Add("全部");
            CbGys2.Items.Add("全部");

            for (int i = 0; i < dt.Rows.Count; i++)
            {
                ListCode.Add(ValidateCol(dt.Rows[i][0]));
                CbGys.Items.Add(ValidateCol(dt.Rows[i][1]));
                ListGys.Add(ValidateCol(dt.Rows[i][1]));

                ListCode1.Add(ValidateCol(dt.Rows[i][0]));
                CbGys2.Items.Add(ValidateCol(dt.Rows[i][1]));
                ListGys1.Add(ValidateCol(dt.Rows[i][1]));
            }

            CbGys.AutoCompleteMode = AutoCompleteMode.SuggestAppend;
            CbGys.AutoCompleteSource = AutoCompleteSource.ListItems;

            CbGys2.AutoCompleteMode = AutoCompleteMode.SuggestAppend;
            CbGys2.AutoCompleteSource = AutoCompleteSource.ListItems;

        }
        private void InitQiJian()
        {
            ListQiJian = new List<clsQiJian>();
            string sql = "select qijian,sTime,eTime from gys001_0001_E002";

            var dt = SqlHelper.GetDataTable(sql);

            if (dt == null || dt.Rows.Count == 0)
            {
                return;
            }

            for (int i = 0; i < dt.Rows.Count; i++)
            {
                clsQiJian cls = new clsQiJian();

                cls.qijian = ValidateCol(dt.Rows[i][0]);
                cls.sTime = ValidateCol(dt.Rows[i]["sTime"]);
                cls.eTime = ValidateCol(dt.Rows[i]["eTime"]);
                ListQiJian.Add(cls);
            }



        }

        private void btn_query_Click(object sender, EventArgs e)
        {
            var dt = LoadProcData();
            this.DataTableUj = dt;
            this.dgv_update.DataSource = this.DataTableUj;

            for (int i = 0; dgv_update.Columns != null && i < dgv_update.Columns.Count; i++)
            {
                dgv_update.Columns[i].ReadOnly = true;
            }
            //readConfig();
            if (dgv_update.Columns != null && dgv_update.Columns.Count > 2)
            {

                dgv_update.Columns["调整日期"].ReadOnly = false;
                dgv_update.Columns["调整金额"].ReadOnly = false;

            }

        }

        private string ValidateCol(object obj)
        {
            if (obj == null)
            {
                return "";
            }
            else
            {
                return obj.ToString();
            }
        }

        private void CbGys_SelectedIndexChanged(object sender, EventArgs e)
        {
            var gys = sender as ComboBox;

            int index = gys.SelectedIndex;

            if (index <= 0 || index > gys.Items.Count)
            {
                return;
            }

            if (index > ListCode.Count)
            {
                return;
            }
            GysCode = ListCode[index];
        }

        private void CbGys2_SelectedIndexChanged(object sender, EventArgs e)
        {
            var gys = sender as ComboBox;

            int index = gys.SelectedIndex;

            if (index <= 0 || index > gys.Items.Count)
            {
                return;
            }

            if (index > ListCode.Count)
            {
                return;
            }
            GysCode1 = ListCode[index];
        }

        private void btn_save_Click(object sender, EventArgs e)
        {
            if (listupdates.Count < 1)
            {
                MessageBox.Show("没有要更改的数据");
                return;
            }
            string sql = "update [uj_Funding_plan_auto] set tzdate={0},tzmoney={1} where id={2}";

            List<SqlParameter> listps = new List<SqlParameter>();

            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < listupdates.Count; i++)
            {
                var item = listupdates[i];
                string tzdate = "@tzdate" + i;
                string tzmoney = "@tzmoney" + i;
                string id = "@id" + i;

                sb.Append(string.Format(sql, tzdate, tzmoney, id) + "\r\n");

                SqlParameter p1 = new SqlParameter();
                p1.ParameterName = tzdate;

                if (item.data1.Trim() == "")
                {
                    p1.Value = DBNull.Value;
                }
                else
                {
                    p1.Value = item.data1;
                }

                SqlParameter p2 = new SqlParameter();
                p2.ParameterName = tzmoney;

                if (item.data2.Trim() == "")
                {
                    p2.Value = DBNull.Value;
                }
                else
                {
                    p2.Value = item.data2;
                }
                listps.Add(new SqlParameter(id, listupdates[i].id));

                listps.Add(p1);
                listps.Add(p2);
            }

            SqlHelper.ExecuteNonQuery(SqlHelper.ConnectionString, sb.ToString(), listps.ToArray());
            listupdates.Clear();

            btn_query.PerformClick();
        }

        private void dgv_update_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            var dgv = sender as DataGridView;

            string id = dgv["id", e.RowIndex].Value.ToString();

            clsUpdateRow cls = listupdates.Find(l => l.id == id);

            if (cls == null)
            {
                cls = new clsUpdateRow();
            }

            cls.id = id;
            var d1 = ValidateCol(dgv["调整日期", e.RowIndex].Value);
            var d2 = ValidateCol(dgv["调整金额", e.RowIndex].Value);
            if (d1 != "")
            {
                DateTime dd = DateTime.Now;

                if (!DateTime.TryParse(d1, out dd))
                {
                    MessageBox.Show("日期输入不正确");
                    return;
                }


            }
            if (d2 != "")
            {

                double ddd = 0.0;
                if (!double.TryParse(d2, out ddd))
                {
                    MessageBox.Show("请输入有效数字");
                    return;
                }

            }

            cls.data1 = d1;
            cls.data2 = d2;

            listupdates.Add(cls);
        }

        public DataTable LoadProcData()
        {

            SqlParameter[] parameters =
              {
                new SqlParameter("@psdate",SqlDbType.Date),
                 new SqlParameter("@pddate",SqlDbType.Date),
                 new SqlParameter("@likechar",SqlDbType.VarChar,200),
                new SqlParameter("@jsplan",SqlDbType.VarChar,4),
                new SqlParameter("@csup_id",SqlDbType.VarChar, 30),

                new SqlParameter("@csup_ids",SqlDbType.VarChar, 30),

              };
            //parameters[0].Value = startTime.Value.Year;
            //parameters[1].Value = startTime.Value.Month;
            //parameters[2].Value = GysCode;
            //parameters[3].Value = endTime.Value.Year;
            //parameters[4].Value = endTime.Value.Month;
            //parameters[5].Value = GysCode1;

            parameters[0].Value = startTime.Value;
            parameters[1].Value = endTime.Value;
            parameters[2].Value = "";
            parameters[3].Value = "";
            parameters[4].Value = "";
            parameters[5].Value = "";

            return SqlHelper.ExecuteProcCommand("uj_Funding_plan_mark", parameters);

        }

        private void dgv_update_ColumnWidthChanged(object sender, DataGridViewColumnEventArgs e)
        {
            dtp.Visible = false;
        }

        private void dgv_update_Scroll(object sender, ScrollEventArgs e)
        {
            dtp.Visible = false;
        }

        private void dgv_update_CellClick(object sender, DataGridViewCellEventArgs e)
        {



            if (e.ColumnIndex == dgv_update.Columns["调整日期"].Index)
            {

                if (dgv_update.CurrentCell.Value.ToString().Trim() != "")
                {
                    dtp.Value = Convert.ToDateTime(dgv_update.CurrentCell.Value);
                }

                _Rectangle = dgv_update.GetCellDisplayRectangle(e.ColumnIndex, e.RowIndex, true); //得到所在单元格位置和大小
                dtp.Size = new Size(_Rectangle.Width, _Rectangle.Height); //把单元格大小赋给时间控件
                dtp.Location = new Point(_Rectangle.X, _Rectangle.Y); //把单元格位置赋给时间控件
                dtp.Visible = true;  //可以显示控件了
            }
            else
                dtp.Visible = false;
        }

        private void dgv_update_CellMouseDown(object sender, DataGridViewCellMouseEventArgs e)
        {
            if (e.ColumnIndex != dgv_update.Columns["调整日期"].Index)
            {
                return;
            }

            if (e.Button == MouseButtons.Right)
            {
                row = e.RowIndex;
                col = e.ColumnIndex;
                dgv_menu.Show(MousePosition.X, MousePosition.Y);

            }
        }

        private void clearDate_Click(object sender, EventArgs e)
        {
            //dgv_update.CurrentCell.Value = "";
            dgv_update[col,row].Value = "";
        }

        public void readConfig()
        {
            string txt = File.ReadAllText("config.txt");

            var arr = txt.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);

            if (arr.Length == 2)
            {
                if (!int.TryParse(arr[0], out col1))
                {

                    col1 = 0;

                }
                if (!int.TryParse(arr[1], out col2))
                {

                    col2 = 1;

                }

            }





        }

    }
}
