﻿using System;
using System.Collections.Generic;
using System.Text;
using UFIDA.U8.Portal.Proxy.supports;
using UFIDA.U8.Portal.Proxy.editors;
using UFIDA.U8.Portal.Proxy.Actions;
using UFSoft.U8.Framework.Login.UI;
using UFIDA.U8.Portal.Framework.Actions;
using UFIDA.U8.Portal.Framework.MainFrames;

namespace UFIDA.U8.Portal.GuaZhangQueR
{
    class MyNetUserControl:INetUserControl
    {
        #region INetUserControl 成员
        
        UCGuaZhangQR ucGzQr = null;
        private IEditorInput _editInput = null;
        private IEditorPart _editPart = null;
        private string _title;

        /// <summary>
        /// EditorInput
        /// </summary>
        public IEditorInput EditorInput
        {
            get
            {
                return _editInput;
            }
            set
            {
                _editInput = value;
            }
        }

        /// <summary>
        /// EditorPart
        /// </summary>
        public IEditorPart EditorPart
        {
            get
            {
                return _editPart;
            }
            set
            {
                _editPart = value;
            }
        }

        /// <summary>
        /// 页签标题
        /// </summary>
        public string Title
        {
            get
            {
                return this._title;
            }
            set
            {
                this._title = value;
            }
        }
        public bool CloseEvent()
        {
            return true;
        }

        public System.Windows.Forms.Control CreateControl(clsLogin login, string MenuID, string Paramters)
        {
            //构造U8登陆对象
            U8Login.clsLogin u8login = new U8Login.clsLoginClass();
            if (login != null)
            {
                u8login.ConstructLogin(login.userToken);
                string taskId = login.GetTaskID("DP");
                u8login.set_TaskId(ref taskId);
            }

            ucGzQr = new UCGuaZhangQR(u8login.UfDbName, u8login.cUserName, u8login.CurDate);
            ucGzQr.Name = "main";

            return ucGzQr;
        }

        public NetAction[] CreateToolbar(clsLogin login)
        {
            return null;
        }



        #endregion
    }
}
